import {CreateMap} from '../Map'

/**
 * @hidden
 */
type RawMap = {
    '-100': ['__', '-99', '-100', -100, '100', '-100', '-'],
    '-99' : ['-100', '-98', '-99', -99, '99', RawMap['-100'][5] | '-99', '-'],
    '-98' : ['-99', '-97', '-98', -98, '98', RawMap['-99'][5] | '-98', '-'],
    '-97' : ['-98', '-96', '-97', -97, '97', RawMap['-98'][5] | '-97', '-'],
    '-96' : ['-97', '-95', '-96', -96, '96', RawMap['-97'][5] | '-96', '-'],
    '-95' : ['-96', '-94', '-95', -95, '95', RawMap['-96'][5] | '-95', '-'],
    '-94' : ['-95', '-93', '-94', -94, '94', RawMap['-95'][5] | '-94', '-'],
    '-93' : ['-94', '-92', '-93', -93, '93', RawMap['-94'][5] | '-93', '-'],
    '-92' : ['-93', '-91', '-92', -92, '92', RawMap['-93'][5] | '-92', '-'],
    '-91' : ['-92', '-90', '-91', -91, '91', RawMap['-92'][5] | '-91', '-'],
    '-90' : ['-91', '-89', '-90', -90, '90', RawMap['-91'][5] | '-90', '-'],
    '-89' : ['-90', '-88', '-89', -89, '89', RawMap['-90'][5] | '-89', '-'],
    '-88' : ['-89', '-87', '-88', -88, '88', RawMap['-89'][5] | '-88', '-'],
    '-87' : ['-88', '-86', '-87', -87, '87', RawMap['-88'][5] | '-87', '-'],
    '-86' : ['-87', '-85', '-86', -86, '86', RawMap['-87'][5] | '-86', '-'],
    '-85' : ['-86', '-84', '-85', -85, '85', RawMap['-86'][5] | '-85', '-'],
    '-84' : ['-85', '-83', '-84', -84, '84', RawMap['-85'][5] | '-84', '-'],
    '-83' : ['-84', '-82', '-83', -83, '83', RawMap['-84'][5] | '-83', '-'],
    '-82' : ['-83', '-81', '-82', -82, '82', RawMap['-83'][5] | '-82', '-'],
    '-81' : ['-82', '-80', '-81', -81, '81', RawMap['-82'][5] | '-81', '-'],
    '-80' : ['-81', '-79', '-80', -80, '80', RawMap['-81'][5] | '-80', '-'],
    '-79' : ['-80', '-78', '-79', -79, '79', RawMap['-80'][5] | '-79', '-'],
    '-78' : ['-79', '-77', '-78', -78, '78', RawMap['-79'][5] | '-78', '-'],
    '-77' : ['-78', '-76', '-77', -77, '77', RawMap['-78'][5] | '-77', '-'],
    '-76' : ['-77', '-75', '-76', -76, '76', RawMap['-77'][5] | '-76', '-'],
    '-75' : ['-76', '-74', '-75', -75, '75', RawMap['-76'][5] | '-75', '-'],
    '-74' : ['-75', '-73', '-74', -74, '74', RawMap['-75'][5] | '-74', '-'],
    '-73' : ['-74', '-72', '-73', -73, '73', RawMap['-74'][5] | '-73', '-'],
    '-72' : ['-73', '-71', '-72', -72, '72', RawMap['-73'][5] | '-72', '-'],
    '-71' : ['-72', '-70', '-71', -71, '71', RawMap['-72'][5] | '-71', '-'],
    '-70' : ['-71', '-69', '-70', -70, '70', RawMap['-71'][5] | '-70', '-'],
    '-69' : ['-70', '-68', '-69', -69, '69', RawMap['-70'][5] | '-69', '-'],
    '-68' : ['-69', '-67', '-68', -68, '68', RawMap['-69'][5] | '-68', '-'],
    '-67' : ['-68', '-66', '-67', -67, '67', RawMap['-68'][5] | '-67', '-'],
    '-66' : ['-67', '-65', '-66', -66, '66', RawMap['-67'][5] | '-66', '-'],
    '-65' : ['-66', '-64', '-65', -65, '65', RawMap['-66'][5] | '-65', '-'],
    '-64' : ['-65', '-63', '-64', -64, '64', RawMap['-65'][5] | '-64', '-'],
    '-63' : ['-64', '-62', '-63', -63, '63', RawMap['-64'][5] | '-63', '-'],
    '-62' : ['-63', '-61', '-62', -62, '62', RawMap['-63'][5] | '-62', '-'],
    '-61' : ['-62', '-60', '-61', -61, '61', RawMap['-62'][5] | '-61', '-'],
    '-60' : ['-61', '-59', '-60', -60, '60', RawMap['-61'][5] | '-60', '-'],
    '-59' : ['-60', '-58', '-59', -59, '59', RawMap['-60'][5] | '-59', '-'],
    '-58' : ['-59', '-57', '-58', -58, '58', RawMap['-59'][5] | '-58', '-'],
    '-57' : ['-58', '-56', '-57', -57, '57', RawMap['-58'][5] | '-57', '-'],
    '-56' : ['-57', '-55', '-56', -56, '56', RawMap['-57'][5] | '-56', '-'],
    '-55' : ['-56', '-54', '-55', -55, '55', RawMap['-56'][5] | '-55', '-'],
    '-54' : ['-55', '-53', '-54', -54, '54', RawMap['-55'][5] | '-54', '-'],
    '-53' : ['-54', '-52', '-53', -53, '53', RawMap['-54'][5] | '-53', '-'],
    '-52' : ['-53', '-51', '-52', -52, '52', RawMap['-53'][5] | '-52', '-'],
    '-51' : ['-52', '-50', '-51', -51, '51', RawMap['-52'][5] | '-51', '-'],
    '-50' : ['-51', '-49', '-50', -50, '50', RawMap['-51'][5] | '-50', '-'],
    '-49' : ['-50', '-48', '-49', -49, '49', RawMap['-50'][5] | '-49', '-'],
    '-48' : ['-49', '-47', '-48', -48, '48', RawMap['-49'][5] | '-48', '-'],
    '-47' : ['-48', '-46', '-47', -47, '47', RawMap['-48'][5] | '-47', '-'],
    '-46' : ['-47', '-45', '-46', -46, '46', RawMap['-47'][5] | '-46', '-'],
    '-45' : ['-46', '-44', '-45', -45, '45', RawMap['-46'][5] | '-45', '-'],
    '-44' : ['-45', '-43', '-44', -44, '44', RawMap['-45'][5] | '-44', '-'],
    '-43' : ['-44', '-42', '-43', -43, '43', RawMap['-44'][5] | '-43', '-'],
    '-42' : ['-43', '-41', '-42', -42, '42', RawMap['-43'][5] | '-42', '-'],
    '-41' : ['-42', '-40', '-41', -41, '41', RawMap['-42'][5] | '-41', '-'],
    '-40' : ['-41', '-39', '-40', -40, '40', RawMap['-41'][5] | '-40', '-'],
    '-39' : ['-40', '-38', '-39', -39, '39', RawMap['-40'][5] | '-39', '-'],
    '-38' : ['-39', '-37', '-38', -38, '38', RawMap['-39'][5] | '-38', '-'],
    '-37' : ['-38', '-36', '-37', -37, '37', RawMap['-38'][5] | '-37', '-'],
    '-36' : ['-37', '-35', '-36', -36, '36', RawMap['-37'][5] | '-36', '-'],
    '-35' : ['-36', '-34', '-35', -35, '35', RawMap['-36'][5] | '-35', '-'],
    '-34' : ['-35', '-33', '-34', -34, '34', RawMap['-35'][5] | '-34', '-'],
    '-33' : ['-34', '-32', '-33', -33, '33', RawMap['-34'][5] | '-33', '-'],
    '-32' : ['-33', '-31', '-32', -32, '32', RawMap['-33'][5] | '-32', '-'],
    '-31' : ['-32', '-30', '-31', -31, '31', RawMap['-32'][5] | '-31', '-'],
    '-30' : ['-31', '-29', '-30', -30, '30', RawMap['-31'][5] | '-30', '-'],
    '-29' : ['-30', '-28', '-29', -29, '29', RawMap['-30'][5] | '-29', '-'],
    '-28' : ['-29', '-27', '-28', -28, '28', RawMap['-29'][5] | '-28', '-'],
    '-27' : ['-28', '-26', '-27', -27, '27', RawMap['-28'][5] | '-27', '-'],
    '-26' : ['-27', '-25', '-26', -26, '26', RawMap['-27'][5] | '-26', '-'],
    '-25' : ['-26', '-24', '-25', -25, '25', RawMap['-26'][5] | '-25', '-'],
    '-24' : ['-25', '-23', '-24', -24, '24', RawMap['-25'][5] | '-24', '-'],
    '-23' : ['-24', '-22', '-23', -23, '23', RawMap['-24'][5] | '-23', '-'],
    '-22' : ['-23', '-21', '-22', -22, '22', RawMap['-23'][5] | '-22', '-'],
    '-21' : ['-22', '-20', '-21', -21, '21', RawMap['-22'][5] | '-21', '-'],
    '-20' : ['-21', '-19', '-20', -20, '20', RawMap['-21'][5] | '-20', '-'],
    '-19' : ['-20', '-18', '-19', -19, '19', RawMap['-20'][5] | '-19', '-'],
    '-18' : ['-19', '-17', '-18', -18, '18', RawMap['-19'][5] | '-18', '-'],
    '-17' : ['-18', '-16', '-17', -17, '17', RawMap['-18'][5] | '-17', '-'],
    '-16' : ['-17', '-15', '-16', -16, '16', RawMap['-17'][5] | '-16', '-'],
    '-15' : ['-16', '-14', '-15', -15, '15', RawMap['-16'][5] | '-15', '-'],
    '-14' : ['-15', '-13', '-14', -14, '14', RawMap['-15'][5] | '-14', '-'],
    '-13' : ['-14', '-12', '-13', -13, '13', RawMap['-14'][5] | '-13', '-'],
    '-12' : ['-13', '-11', '-12', -12, '12', RawMap['-13'][5] | '-12', '-'],
    '-11' : ['-12', '-10', '-11', -11, '11', RawMap['-12'][5] | '-11', '-'],
    '-10' : ['-11', '-9', '-10', -10, '10', RawMap['-11'][5] | '-10', '-'],
    '-9'  : ['-10', '-8', '-9', -9, '9', RawMap['-10'][5] | '-9', '-'],
    '-8'  : ['-9', '-7', '-8', -8, '8', RawMap['-9'][5] | '-8', '-'],
    '-7'  : ['-8', '-6', '-7', -7, '7', RawMap['-8'][5] | '-7', '-'],
    '-6'  : ['-7', '-5', '-6', -6, '6', RawMap['-7'][5] | '-6', '-'],
    '-5'  : ['-6', '-4', '-5', -5, '5', RawMap['-6'][5] | '-5', '-'],
    '-4'  : ['-5', '-3', '-4', -4, '4', RawMap['-5'][5] | '-4', '-'],
    '-3'  : ['-4', '-2', '-3', -3, '3', RawMap['-4'][5] | '-3', '-'],
    '-2'  : ['-3', '-1', '-2', -2, '2', RawMap['-3'][5] | '-2', '-'],
    '-1'  : ['-2', '0', '-1', -1, '1', RawMap['-2'][5] | '-1', '-'],
    '0'   : ['-1', '1', '0', 0, '0', RawMap['-1'][5] | '0', '0'],
    '1'   : ['0', '2', '1', 1, '-1', RawMap['0'][5] | '1', '+'],
    '2'   : ['1', '3', '2', 2, '-2', RawMap['1'][5] | '2', '+'],
    '3'   : ['2', '4', '3', 3, '-3', RawMap['2'][5] | '3', '+'],
    '4'   : ['3', '5', '4', 4, '-4', RawMap['3'][5] | '4', '+'],
    '5'   : ['4', '6', '5', 5, '-5', RawMap['4'][5] | '5', '+'],
    '6'   : ['5', '7', '6', 6, '-6', RawMap['5'][5] | '6', '+'],
    '7'   : ['6', '8', '7', 7, '-7', RawMap['6'][5] | '7', '+'],
    '8'   : ['7', '9', '8', 8, '-8', RawMap['7'][5] | '8', '+'],
    '9'   : ['8', '10', '9', 9, '-9', RawMap['8'][5] | '9', '+'],
    '10'  : ['9', '11', '10', 10, '-10', RawMap['9'][5] | '10', '+'],
    '11'  : ['10', '12', '11', 11, '-11', RawMap['10'][5] | '11', '+'],
    '12'  : ['11', '13', '12', 12, '-12', RawMap['11'][5] | '12', '+'],
    '13'  : ['12', '14', '13', 13, '-13', RawMap['12'][5] | '13', '+'],
    '14'  : ['13', '15', '14', 14, '-14', RawMap['13'][5] | '14', '+'],
    '15'  : ['14', '16', '15', 15, '-15', RawMap['14'][5] | '15', '+'],
    '16'  : ['15', '17', '16', 16, '-16', RawMap['15'][5] | '16', '+'],
    '17'  : ['16', '18', '17', 17, '-17', RawMap['16'][5] | '17', '+'],
    '18'  : ['17', '19', '18', 18, '-18', RawMap['17'][5] | '18', '+'],
    '19'  : ['18', '20', '19', 19, '-19', RawMap['18'][5] | '19', '+'],
    '20'  : ['19', '21', '20', 20, '-20', RawMap['19'][5] | '20', '+'],
    '21'  : ['20', '22', '21', 21, '-21', RawMap['20'][5] | '21', '+'],
    '22'  : ['21', '23', '22', 22, '-22', RawMap['21'][5] | '22', '+'],
    '23'  : ['22', '24', '23', 23, '-23', RawMap['22'][5] | '23', '+'],
    '24'  : ['23', '25', '24', 24, '-24', RawMap['23'][5] | '24', '+'],
    '25'  : ['24', '26', '25', 25, '-25', RawMap['24'][5] | '25', '+'],
    '26'  : ['25', '27', '26', 26, '-26', RawMap['25'][5] | '26', '+'],
    '27'  : ['26', '28', '27', 27, '-27', RawMap['26'][5] | '27', '+'],
    '28'  : ['27', '29', '28', 28, '-28', RawMap['27'][5] | '28', '+'],
    '29'  : ['28', '30', '29', 29, '-29', RawMap['28'][5] | '29', '+'],
    '30'  : ['29', '31', '30', 30, '-30', RawMap['29'][5] | '30', '+'],
    '31'  : ['30', '32', '31', 31, '-31', RawMap['30'][5] | '31', '+'],
    '32'  : ['31', '33', '32', 32, '-32', RawMap['31'][5] | '32', '+'],
    '33'  : ['32', '34', '33', 33, '-33', RawMap['32'][5] | '33', '+'],
    '34'  : ['33', '35', '34', 34, '-34', RawMap['33'][5] | '34', '+'],
    '35'  : ['34', '36', '35', 35, '-35', RawMap['34'][5] | '35', '+'],
    '36'  : ['35', '37', '36', 36, '-36', RawMap['35'][5] | '36', '+'],
    '37'  : ['36', '38', '37', 37, '-37', RawMap['36'][5] | '37', '+'],
    '38'  : ['37', '39', '38', 38, '-38', RawMap['37'][5] | '38', '+'],
    '39'  : ['38', '40', '39', 39, '-39', RawMap['38'][5] | '39', '+'],
    '40'  : ['39', '41', '40', 40, '-40', RawMap['39'][5] | '40', '+'],
    '41'  : ['40', '42', '41', 41, '-41', RawMap['40'][5] | '41', '+'],
    '42'  : ['41', '43', '42', 42, '-42', RawMap['41'][5] | '42', '+'],
    '43'  : ['42', '44', '43', 43, '-43', RawMap['42'][5] | '43', '+'],
    '44'  : ['43', '45', '44', 44, '-44', RawMap['43'][5] | '44', '+'],
    '45'  : ['44', '46', '45', 45, '-45', RawMap['44'][5] | '45', '+'],
    '46'  : ['45', '47', '46', 46, '-46', RawMap['45'][5] | '46', '+'],
    '47'  : ['46', '48', '47', 47, '-47', RawMap['46'][5] | '47', '+'],
    '48'  : ['47', '49', '48', 48, '-48', RawMap['47'][5] | '48', '+'],
    '49'  : ['48', '50', '49', 49, '-49', RawMap['48'][5] | '49', '+'],
    '50'  : ['49', '51', '50', 50, '-50', RawMap['49'][5] | '50', '+'],
    '51'  : ['50', '52', '51', 51, '-51', RawMap['50'][5] | '51', '+'],
    '52'  : ['51', '53', '52', 52, '-52', RawMap['51'][5] | '52', '+'],
    '53'  : ['52', '54', '53', 53, '-53', RawMap['52'][5] | '53', '+'],
    '54'  : ['53', '55', '54', 54, '-54', RawMap['53'][5] | '54', '+'],
    '55'  : ['54', '56', '55', 55, '-55', RawMap['54'][5] | '55', '+'],
    '56'  : ['55', '57', '56', 56, '-56', RawMap['55'][5] | '56', '+'],
    '57'  : ['56', '58', '57', 57, '-57', RawMap['56'][5] | '57', '+'],
    '58'  : ['57', '59', '58', 58, '-58', RawMap['57'][5] | '58', '+'],
    '59'  : ['58', '60', '59', 59, '-59', RawMap['58'][5] | '59', '+'],
    '60'  : ['59', '61', '60', 60, '-60', RawMap['59'][5] | '60', '+'],
    '61'  : ['60', '62', '61', 61, '-61', RawMap['60'][5] | '61', '+'],
    '62'  : ['61', '63', '62', 62, '-62', RawMap['61'][5] | '62', '+'],
    '63'  : ['62', '64', '63', 63, '-63', RawMap['62'][5] | '63', '+'],
    '64'  : ['63', '65', '64', 64, '-64', RawMap['63'][5] | '64', '+'],
    '65'  : ['64', '66', '65', 65, '-65', RawMap['64'][5] | '65', '+'],
    '66'  : ['65', '67', '66', 66, '-66', RawMap['65'][5] | '66', '+'],
    '67'  : ['66', '68', '67', 67, '-67', RawMap['66'][5] | '67', '+'],
    '68'  : ['67', '69', '68', 68, '-68', RawMap['67'][5] | '68', '+'],
    '69'  : ['68', '70', '69', 69, '-69', RawMap['68'][5] | '69', '+'],
    '70'  : ['69', '71', '70', 70, '-70', RawMap['69'][5] | '70', '+'],
    '71'  : ['70', '72', '71', 71, '-71', RawMap['70'][5] | '71', '+'],
    '72'  : ['71', '73', '72', 72, '-72', RawMap['71'][5] | '72', '+'],
    '73'  : ['72', '74', '73', 73, '-73', RawMap['72'][5] | '73', '+'],
    '74'  : ['73', '75', '74', 74, '-74', RawMap['73'][5] | '74', '+'],
    '75'  : ['74', '76', '75', 75, '-75', RawMap['74'][5] | '75', '+'],
    '76'  : ['75', '77', '76', 76, '-76', RawMap['75'][5] | '76', '+'],
    '77'  : ['76', '78', '77', 77, '-77', RawMap['76'][5] | '77', '+'],
    '78'  : ['77', '79', '78', 78, '-78', RawMap['77'][5] | '78', '+'],
    '79'  : ['78', '80', '79', 79, '-79', RawMap['78'][5] | '79', '+'],
    '80'  : ['79', '81', '80', 80, '-80', RawMap['79'][5] | '80', '+'],
    '81'  : ['80', '82', '81', 81, '-81', RawMap['80'][5] | '81', '+'],
    '82'  : ['81', '83', '82', 82, '-82', RawMap['81'][5] | '82', '+'],
    '83'  : ['82', '84', '83', 83, '-83', RawMap['82'][5] | '83', '+'],
    '84'  : ['83', '85', '84', 84, '-84', RawMap['83'][5] | '84', '+'],
    '85'  : ['84', '86', '85', 85, '-85', RawMap['84'][5] | '85', '+'],
    '86'  : ['85', '87', '86', 86, '-86', RawMap['85'][5] | '86', '+'],
    '87'  : ['86', '88', '87', 87, '-87', RawMap['86'][5] | '87', '+'],
    '88'  : ['87', '89', '88', 88, '-88', RawMap['87'][5] | '88', '+'],
    '89'  : ['88', '90', '89', 89, '-89', RawMap['88'][5] | '89', '+'],
    '90'  : ['89', '91', '90', 90, '-90', RawMap['89'][5] | '90', '+'],
    '91'  : ['90', '92', '91', 91, '-91', RawMap['90'][5] | '91', '+'],
    '92'  : ['91', '93', '92', 92, '-92', RawMap['91'][5] | '92', '+'],
    '93'  : ['92', '94', '93', 93, '-93', RawMap['92'][5] | '93', '+'],
    '94'  : ['93', '95', '94', 94, '-94', RawMap['93'][5] | '94', '+'],
    '95'  : ['94', '96', '95', 95, '-95', RawMap['94'][5] | '95', '+'],
    '96'  : ['95', '97', '96', 96, '-96', RawMap['95'][5] | '96', '+'],
    '97'  : ['96', '98', '97', 97, '-97', RawMap['96'][5] | '97', '+'],
    '98'  : ['97', '99', '98', 98, '-98', RawMap['97'][5] | '98', '+'],
    '99'  : ['98', '100', '99', 99, '-99', RawMap['98'][5] | '99', '+'],
    '100' : ['99', '__', '100', 100, '-100', RawMap['99'][5] | '100', '+']
}

/**
 * @hidden
 */
type MapKeys = {
    '-': '-100' | '-99' | '-98' | '-97' | '-96' | '-95' | '-94' | '-93' | '-92' | '-91' | '-90' | '-89' | '-88' | '-87' | '-86' | '-85' | '-84' | '-83' | '-82' | '-81' | '-80' | '-79' | '-78' | '-77' | '-76' | '-75' | '-74' | '-73' | '-72' | '-71' | '-70' | '-69' | '-68' | '-67' | '-66' | '-65' | '-64' | '-63' | '-62' | '-61' | '-60' | '-59' | '-58' | '-57' | '-56' | '-55' | '-54' | '-53' | '-52' | '-51' | '-50' | '-49' | '-48' | '-47' | '-46' | '-45' | '-44' | '-43' | '-42' | '-41' | '-40' | '-39' | '-38' | '-37' | '-36' | '-35' | '-34' | '-33' | '-32' | '-31' | '-30' | '-29' | '-28' | '-27' | '-26' | '-25' | '-24' | '-23' | '-22' | '-21' | '-20' | '-19' | '-18' | '-17' | '-16' | '-15' | '-14' | '-13' | '-12' | '-11' | '-10' | '-9' | '-8' | '-7' | '-6' | '-5' | '-4' | '-3' | '-2' | '-1'
    '0': '0'
    '+': '1' | '2' | '3' | '4' | '5' | '6' | '7' | '8' | '9' | '10' | '11' | '12' | '13' | '14' | '15' | '16' | '17' | '18' | '19' | '20' | '21' | '22' | '23' | '24' | '25' | '26' | '27' | '28' | '29' | '30' | '31' | '32' | '33' | '34' | '35' | '36' | '37' | '38' | '39' | '40' | '41' | '42' | '43' | '44' | '45' | '46' | '47' | '48' | '49' | '50' | '51' | '52' | '53' | '54' | '55' | '56' | '57' | '58' | '59' | '60' | '61' | '62' | '63' | '64' | '65' | '66' | '67' | '68' | '69' | '70' | '71' | '72' | '73' | '74' | '75' | '76' | '77' | '78' | '79' | '80' | '81' | '82' | '83' | '84' | '85' | '86' | '87' | '88' | '89' | '90' | '91' | '92' | '93' | '94' | '95' | '96' | '97' | '98' | '99' | '100'
}

/**
Describes a map of number relationships
*/
export type NumberMap = CreateMap<MapKeys, RawMap>
