import {CreateMap} from '../Map'

/**
 * @hidden
 */
type RawMap = {
    '-100px': ['__', '-99px', '-100px', -100, '100px', '-100px', '-'],
    '-99px': ['-100px', '-98px', '-99px', -99, '99px', RawMap['-100px'][5] | '-99px', '-'],
    '-98px': ['-99px', '-97px', '-98px', -98, '98px', RawMap['-99px'][5] | '-98px', '-'],
    '-97px': ['-98px', '-96px', '-97px', -97, '97px', RawMap['-98px'][5] | '-97px', '-'],
    '-96px': ['-97px', '-95px', '-96px', -96, '96px', RawMap['-97px'][5] | '-96px', '-'],
    '-95px': ['-96px', '-94px', '-95px', -95, '95px', RawMap['-96px'][5] | '-95px', '-'],
    '-94px': ['-95px', '-93px', '-94px', -94, '94px', RawMap['-95px'][5] | '-94px', '-'],
    '-93px': ['-94px', '-92px', '-93px', -93, '93px', RawMap['-94px'][5] | '-93px', '-'],
    '-92px': ['-93px', '-91px', '-92px', -92, '92px', RawMap['-93px'][5] | '-92px', '-'],
    '-91px': ['-92px', '-90px', '-91px', -91, '91px', RawMap['-92px'][5] | '-91px', '-'],
    '-90px': ['-91px', '-89px', '-90px', -90, '90px', RawMap['-91px'][5] | '-90px', '-'],
    '-89px': ['-90px', '-88px', '-89px', -89, '89px', RawMap['-90px'][5] | '-89px', '-'],
    '-88px': ['-89px', '-87px', '-88px', -88, '88px', RawMap['-89px'][5] | '-88px', '-'],
    '-87px': ['-88px', '-86px', '-87px', -87, '87px', RawMap['-88px'][5] | '-87px', '-'],
    '-86px': ['-87px', '-85px', '-86px', -86, '86px', RawMap['-87px'][5] | '-86px', '-'],
    '-85px': ['-86px', '-84px', '-85px', -85, '85px', RawMap['-86px'][5] | '-85px', '-'],
    '-84px': ['-85px', '-83px', '-84px', -84, '84px', RawMap['-85px'][5] | '-84px', '-'],
    '-83px': ['-84px', '-82px', '-83px', -83, '83px', RawMap['-84px'][5] | '-83px', '-'],
    '-82px': ['-83px', '-81px', '-82px', -82, '82px', RawMap['-83px'][5] | '-82px', '-'],
    '-81px': ['-82px', '-80px', '-81px', -81, '81px', RawMap['-82px'][5] | '-81px', '-'],
    '-80px': ['-81px', '-79px', '-80px', -80, '80px', RawMap['-81px'][5] | '-80px', '-'],
    '-79px': ['-80px', '-78px', '-79px', -79, '79px', RawMap['-80px'][5] | '-79px', '-'],
    '-78px': ['-79px', '-77px', '-78px', -78, '78px', RawMap['-79px'][5] | '-78px', '-'],
    '-77px': ['-78px', '-76px', '-77px', -77, '77px', RawMap['-78px'][5] | '-77px', '-'],
    '-76px': ['-77px', '-75px', '-76px', -76, '76px', RawMap['-77px'][5] | '-76px', '-'],
    '-75px': ['-76px', '-74px', '-75px', -75, '75px', RawMap['-76px'][5] | '-75px', '-'],
    '-74px': ['-75px', '-73px', '-74px', -74, '74px', RawMap['-75px'][5] | '-74px', '-'],
    '-73px': ['-74px', '-72px', '-73px', -73, '73px', RawMap['-74px'][5] | '-73px', '-'],
    '-72px': ['-73px', '-71px', '-72px', -72, '72px', RawMap['-73px'][5] | '-72px', '-'],
    '-71px': ['-72px', '-70px', '-71px', -71, '71px', RawMap['-72px'][5] | '-71px', '-'],
    '-70px': ['-71px', '-69px', '-70px', -70, '70px', RawMap['-71px'][5] | '-70px', '-'],
    '-69px': ['-70px', '-68px', '-69px', -69, '69px', RawMap['-70px'][5] | '-69px', '-'],
    '-68px': ['-69px', '-67px', '-68px', -68, '68px', RawMap['-69px'][5] | '-68px', '-'],
    '-67px': ['-68px', '-66px', '-67px', -67, '67px', RawMap['-68px'][5] | '-67px', '-'],
    '-66px': ['-67px', '-65px', '-66px', -66, '66px', RawMap['-67px'][5] | '-66px', '-'],
    '-65px': ['-66px', '-64px', '-65px', -65, '65px', RawMap['-66px'][5] | '-65px', '-'],
    '-64px': ['-65px', '-63px', '-64px', -64, '64px', RawMap['-65px'][5] | '-64px', '-'],
    '-63px': ['-64px', '-62px', '-63px', -63, '63px', RawMap['-64px'][5] | '-63px', '-'],
    '-62px': ['-63px', '-61px', '-62px', -62, '62px', RawMap['-63px'][5] | '-62px', '-'],
    '-61px': ['-62px', '-60px', '-61px', -61, '61px', RawMap['-62px'][5] | '-61px', '-'],
    '-60px': ['-61px', '-59px', '-60px', -60, '60px', RawMap['-61px'][5] | '-60px', '-'],
    '-59px': ['-60px', '-58px', '-59px', -59, '59px', RawMap['-60px'][5] | '-59px', '-'],
    '-58px': ['-59px', '-57px', '-58px', -58, '58px', RawMap['-59px'][5] | '-58px', '-'],
    '-57px': ['-58px', '-56px', '-57px', -57, '57px', RawMap['-58px'][5] | '-57px', '-'],
    '-56px': ['-57px', '-55px', '-56px', -56, '56px', RawMap['-57px'][5] | '-56px', '-'],
    '-55px': ['-56px', '-54px', '-55px', -55, '55px', RawMap['-56px'][5] | '-55px', '-'],
    '-54px': ['-55px', '-53px', '-54px', -54, '54px', RawMap['-55px'][5] | '-54px', '-'],
    '-53px': ['-54px', '-52px', '-53px', -53, '53px', RawMap['-54px'][5] | '-53px', '-'],
    '-52px': ['-53px', '-51px', '-52px', -52, '52px', RawMap['-53px'][5] | '-52px', '-'],
    '-51px': ['-52px', '-50px', '-51px', -51, '51px', RawMap['-52px'][5] | '-51px', '-'],
    '-50px': ['-51px', '-49px', '-50px', -50, '50px', RawMap['-51px'][5] | '-50px', '-'],
    '-49px': ['-50px', '-48px', '-49px', -49, '49px', RawMap['-50px'][5] | '-49px', '-'],
    '-48px': ['-49px', '-47px', '-48px', -48, '48px', RawMap['-49px'][5] | '-48px', '-'],
    '-47px': ['-48px', '-46px', '-47px', -47, '47px', RawMap['-48px'][5] | '-47px', '-'],
    '-46px': ['-47px', '-45px', '-46px', -46, '46px', RawMap['-47px'][5] | '-46px', '-'],
    '-45px': ['-46px', '-44px', '-45px', -45, '45px', RawMap['-46px'][5] | '-45px', '-'],
    '-44px': ['-45px', '-43px', '-44px', -44, '44px', RawMap['-45px'][5] | '-44px', '-'],
    '-43px': ['-44px', '-42px', '-43px', -43, '43px', RawMap['-44px'][5] | '-43px', '-'],
    '-42px': ['-43px', '-41px', '-42px', -42, '42px', RawMap['-43px'][5] | '-42px', '-'],
    '-41px': ['-42px', '-40px', '-41px', -41, '41px', RawMap['-42px'][5] | '-41px', '-'],
    '-40px': ['-41px', '-39px', '-40px', -40, '40px', RawMap['-41px'][5] | '-40px', '-'],
    '-39px': ['-40px', '-38px', '-39px', -39, '39px', RawMap['-40px'][5] | '-39px', '-'],
    '-38px': ['-39px', '-37px', '-38px', -38, '38px', RawMap['-39px'][5] | '-38px', '-'],
    '-37px': ['-38px', '-36px', '-37px', -37, '37px', RawMap['-38px'][5] | '-37px', '-'],
    '-36px': ['-37px', '-35px', '-36px', -36, '36px', RawMap['-37px'][5] | '-36px', '-'],
    '-35px': ['-36px', '-34px', '-35px', -35, '35px', RawMap['-36px'][5] | '-35px', '-'],
    '-34px': ['-35px', '-33px', '-34px', -34, '34px', RawMap['-35px'][5] | '-34px', '-'],
    '-33px': ['-34px', '-32px', '-33px', -33, '33px', RawMap['-34px'][5] | '-33px', '-'],
    '-32px': ['-33px', '-31px', '-32px', -32, '32px', RawMap['-33px'][5] | '-32px', '-'],
    '-31px': ['-32px', '-30px', '-31px', -31, '31px', RawMap['-32px'][5] | '-31px', '-'],
    '-30px': ['-31px', '-29px', '-30px', -30, '30px', RawMap['-31px'][5] | '-30px', '-'],
    '-29px': ['-30px', '-28px', '-29px', -29, '29px', RawMap['-30px'][5] | '-29px', '-'],
    '-28px': ['-29px', '-27px', '-28px', -28, '28px', RawMap['-29px'][5] | '-28px', '-'],
    '-27px': ['-28px', '-26px', '-27px', -27, '27px', RawMap['-28px'][5] | '-27px', '-'],
    '-26px': ['-27px', '-25px', '-26px', -26, '26px', RawMap['-27px'][5] | '-26px', '-'],
    '-25px': ['-26px', '-24px', '-25px', -25, '25px', RawMap['-26px'][5] | '-25px', '-'],
    '-24px': ['-25px', '-23px', '-24px', -24, '24px', RawMap['-25px'][5] | '-24px', '-'],
    '-23px': ['-24px', '-22px', '-23px', -23, '23px', RawMap['-24px'][5] | '-23px', '-'],
    '-22px': ['-23px', '-21px', '-22px', -22, '22px', RawMap['-23px'][5] | '-22px', '-'],
    '-21px': ['-22px', '-20px', '-21px', -21, '21px', RawMap['-22px'][5] | '-21px', '-'],
    '-20px': ['-21px', '-19px', '-20px', -20, '20px', RawMap['-21px'][5] | '-20px', '-'],
    '-19px': ['-20px', '-18px', '-19px', -19, '19px', RawMap['-20px'][5] | '-19px', '-'],
    '-18px': ['-19px', '-17px', '-18px', -18, '18px', RawMap['-19px'][5] | '-18px', '-'],
    '-17px': ['-18px', '-16px', '-17px', -17, '17px', RawMap['-18px'][5] | '-17px', '-'],
    '-16px': ['-17px', '-15px', '-16px', -16, '16px', RawMap['-17px'][5] | '-16px', '-'],
    '-15px': ['-16px', '-14px', '-15px', -15, '15px', RawMap['-16px'][5] | '-15px', '-'],
    '-14px': ['-15px', '-13px', '-14px', -14, '14px', RawMap['-15px'][5] | '-14px', '-'],
    '-13px': ['-14px', '-12px', '-13px', -13, '13px', RawMap['-14px'][5] | '-13px', '-'],
    '-12px': ['-13px', '-11px', '-12px', -12, '12px', RawMap['-13px'][5] | '-12px', '-'],
    '-11px': ['-12px', '-10px', '-11px', -11, '11px', RawMap['-12px'][5] | '-11px', '-'],
    '-10px': ['-11px', '-9px', '-10px', -10, '10px', RawMap['-11px'][5] | '-10px', '-'],
    '-9px': ['-10px', '-8px', '-9px', -9, '9px', RawMap['-10px'][5] | '-9px', '-'],
    '-8px': ['-9px', '-7px', '-8px', -8, '8px', RawMap['-9px'][5] | '-8px', '-'],
    '-7px': ['-8px', '-6px', '-7px', -7, '7px', RawMap['-8px'][5] | '-7px', '-'],
    '-6px': ['-7px', '-5px', '-6px', -6, '6px', RawMap['-7px'][5] | '-6px', '-'],
    '-5px': ['-6px', '-4px', '-5px', -5, '5px', RawMap['-6px'][5] | '-5px', '-'],
    '-4px': ['-5px', '-3px', '-4px', -4, '4px', RawMap['-5px'][5] | '-4px', '-'],
    '-3px': ['-4px', '-2px', '-3px', -3, '3px', RawMap['-4px'][5] | '-3px', '-'],
    '-2px': ['-3px', '-1px', '-2px', -2, '2px', RawMap['-3px'][5] | '-2px', '-'],
    '-1px': ['-2px', '0px', '-1px', -1, '1px', RawMap['-2px'][5] | '-1px', '-'],
    '0': ['-1px', '1px', '0px', 0, '0px', RawMap['-1px'][5] | '0px', '0'],
    '0px': ['-1px', '1px', '0px', 0, '0px', RawMap['-1px'][5] | '0px', '0'],
    '1px': ['0px', '2px', '1px', 1, '-1px', RawMap['0px'][5] | '1px', '+'],
    '2px': ['1px', '3px', '2px', 2, '-2px', RawMap['1px'][5] | '2px', '+'],
    '3px': ['2px', '4px', '3px', 3, '-3px', RawMap['2px'][5] | '3px', '+'],
    '4px': ['3px', '5px', '4px', 4, '-4px', RawMap['3px'][5] | '4px', '+'],
    '5px': ['4px', '6px', '5px', 5, '-5px', RawMap['4px'][5] | '5px', '+'],
    '6px': ['5px', '7px', '6px', 6, '-6px', RawMap['5px'][5] | '6px', '+'],
    '7px': ['6px', '8px', '7px', 7, '-7px', RawMap['6px'][5] | '7px', '+'],
    '8px': ['7px', '9px', '8px', 8, '-8px', RawMap['7px'][5] | '8px', '+'],
    '9px': ['8px', '10px', '9px', 9, '-9px', RawMap['8px'][5] | '9px', '+'],
    '10px': ['9px', '11px', '10px', 10, '-10px', RawMap['9px'][5] | '10px', '+'],
    '11px': ['10px', '12px', '11px', 11, '-11px', RawMap['10px'][5] | '11px', '+'],
    '12px': ['11px', '13px', '12px', 12, '-12px', RawMap['11px'][5] | '12px', '+'],
    '13px': ['12px', '14px', '13px', 13, '-13px', RawMap['12px'][5] | '13px', '+'],
    '14px': ['13px', '15px', '14px', 14, '-14px', RawMap['13px'][5] | '14px', '+'],
    '15px': ['14px', '16px', '15px', 15, '-15px', RawMap['14px'][5] | '15px', '+'],
    '16px': ['15px', '17px', '16px', 16, '-16px', RawMap['15px'][5] | '16px', '+'],
    '17px': ['16px', '18px', '17px', 17, '-17px', RawMap['16px'][5] | '17px', '+'],
    '18px': ['17px', '19px', '18px', 18, '-18px', RawMap['17px'][5] | '18px', '+'],
    '19px': ['18px', '20px', '19px', 19, '-19px', RawMap['18px'][5] | '19px', '+'],
    '20px': ['19px', '21px', '20px', 20, '-20px', RawMap['19px'][5] | '20px', '+'],
    '21px': ['20px', '22px', '21px', 21, '-21px', RawMap['20px'][5] | '21px', '+'],
    '22px': ['21px', '23px', '22px', 22, '-22px', RawMap['21px'][5] | '22px', '+'],
    '23px': ['22px', '24px', '23px', 23, '-23px', RawMap['22px'][5] | '23px', '+'],
    '24px': ['23px', '25px', '24px', 24, '-24px', RawMap['23px'][5] | '24px', '+'],
    '25px': ['24px', '26px', '25px', 25, '-25px', RawMap['24px'][5] | '25px', '+'],
    '26px': ['25px', '27px', '26px', 26, '-26px', RawMap['25px'][5] | '26px', '+'],
    '27px': ['26px', '28px', '27px', 27, '-27px', RawMap['26px'][5] | '27px', '+'],
    '28px': ['27px', '29px', '28px', 28, '-28px', RawMap['27px'][5] | '28px', '+'],
    '29px': ['28px', '30px', '29px', 29, '-29px', RawMap['28px'][5] | '29px', '+'],
    '30px': ['29px', '31px', '30px', 30, '-30px', RawMap['29px'][5] | '30px', '+'],
    '31px': ['30px', '32px', '31px', 31, '-31px', RawMap['30px'][5] | '31px', '+'],
    '32px': ['31px', '33px', '32px', 32, '-32px', RawMap['31px'][5] | '32px', '+'],
    '33px': ['32px', '34px', '33px', 33, '-33px', RawMap['32px'][5] | '33px', '+'],
    '34px': ['33px', '35px', '34px', 34, '-34px', RawMap['33px'][5] | '34px', '+'],
    '35px': ['34px', '36px', '35px', 35, '-35px', RawMap['34px'][5] | '35px', '+'],
    '36px': ['35px', '37px', '36px', 36, '-36px', RawMap['35px'][5] | '36px', '+'],
    '37px': ['36px', '38px', '37px', 37, '-37px', RawMap['36px'][5] | '37px', '+'],
    '38px': ['37px', '39px', '38px', 38, '-38px', RawMap['37px'][5] | '38px', '+'],
    '39px': ['38px', '40px', '39px', 39, '-39px', RawMap['38px'][5] | '39px', '+'],
    '40px': ['39px', '41px', '40px', 40, '-40px', RawMap['39px'][5] | '40px', '+'],
    '41px': ['40px', '42px', '41px', 41, '-41px', RawMap['40px'][5] | '41px', '+'],
    '42px': ['41px', '43px', '42px', 42, '-42px', RawMap['41px'][5] | '42px', '+'],
    '43px': ['42px', '44px', '43px', 43, '-43px', RawMap['42px'][5] | '43px', '+'],
    '44px': ['43px', '45px', '44px', 44, '-44px', RawMap['43px'][5] | '44px', '+'],
    '45px': ['44px', '46px', '45px', 45, '-45px', RawMap['44px'][5] | '45px', '+'],
    '46px': ['45px', '47px', '46px', 46, '-46px', RawMap['45px'][5] | '46px', '+'],
    '47px': ['46px', '48px', '47px', 47, '-47px', RawMap['46px'][5] | '47px', '+'],
    '48px': ['47px', '49px', '48px', 48, '-48px', RawMap['47px'][5] | '48px', '+'],
    '49px': ['48px', '50px', '49px', 49, '-49px', RawMap['48px'][5] | '49px', '+'],
    '50px': ['49px', '51px', '50px', 50, '-50px', RawMap['49px'][5] | '50px', '+'],
    '51px': ['50px', '52px', '51px', 51, '-51px', RawMap['50px'][5] | '51px', '+'],
    '52px': ['51px', '53px', '52px', 52, '-52px', RawMap['51px'][5] | '52px', '+'],
    '53px': ['52px', '54px', '53px', 53, '-53px', RawMap['52px'][5] | '53px', '+'],
    '54px': ['53px', '55px', '54px', 54, '-54px', RawMap['53px'][5] | '54px', '+'],
    '55px': ['54px', '56px', '55px', 55, '-55px', RawMap['54px'][5] | '55px', '+'],
    '56px': ['55px', '57px', '56px', 56, '-56px', RawMap['55px'][5] | '56px', '+'],
    '57px': ['56px', '58px', '57px', 57, '-57px', RawMap['56px'][5] | '57px', '+'],
    '58px': ['57px', '59px', '58px', 58, '-58px', RawMap['57px'][5] | '58px', '+'],
    '59px': ['58px', '60px', '59px', 59, '-59px', RawMap['58px'][5] | '59px', '+'],
    '60px': ['59px', '61px', '60px', 60, '-60px', RawMap['59px'][5] | '60px', '+'],
    '61px': ['60px', '62px', '61px', 61, '-61px', RawMap['60px'][5] | '61px', '+'],
    '62px': ['61px', '63px', '62px', 62, '-62px', RawMap['61px'][5] | '62px', '+'],
    '63px': ['62px', '64px', '63px', 63, '-63px', RawMap['62px'][5] | '63px', '+'],
    '64px': ['63px', '65px', '64px', 64, '-64px', RawMap['63px'][5] | '64px', '+'],
    '65px': ['64px', '66px', '65px', 65, '-65px', RawMap['64px'][5] | '65px', '+'],
    '66px': ['65px', '67px', '66px', 66, '-66px', RawMap['65px'][5] | '66px', '+'],
    '67px': ['66px', '68px', '67px', 67, '-67px', RawMap['66px'][5] | '67px', '+'],
    '68px': ['67px', '69px', '68px', 68, '-68px', RawMap['67px'][5] | '68px', '+'],
    '69px': ['68px', '70px', '69px', 69, '-69px', RawMap['68px'][5] | '69px', '+'],
    '70px': ['69px', '71px', '70px', 70, '-70px', RawMap['69px'][5] | '70px', '+'],
    '71px': ['70px', '72px', '71px', 71, '-71px', RawMap['70px'][5] | '71px', '+'],
    '72px': ['71px', '73px', '72px', 72, '-72px', RawMap['71px'][5] | '72px', '+'],
    '73px': ['72px', '74px', '73px', 73, '-73px', RawMap['72px'][5] | '73px', '+'],
    '74px': ['73px', '75px', '74px', 74, '-74px', RawMap['73px'][5] | '74px', '+'],
    '75px': ['74px', '76px', '75px', 75, '-75px', RawMap['74px'][5] | '75px', '+'],
    '76px': ['75px', '77px', '76px', 76, '-76px', RawMap['75px'][5] | '76px', '+'],
    '77px': ['76px', '78px', '77px', 77, '-77px', RawMap['76px'][5] | '77px', '+'],
    '78px': ['77px', '79px', '78px', 78, '-78px', RawMap['77px'][5] | '78px', '+'],
    '79px': ['78px', '80px', '79px', 79, '-79px', RawMap['78px'][5] | '79px', '+'],
    '80px': ['79px', '81px', '80px', 80, '-80px', RawMap['79px'][5] | '80px', '+'],
    '81px': ['80px', '82px', '81px', 81, '-81px', RawMap['80px'][5] | '81px', '+'],
    '82px': ['81px', '83px', '82px', 82, '-82px', RawMap['81px'][5] | '82px', '+'],
    '83px': ['82px', '84px', '83px', 83, '-83px', RawMap['82px'][5] | '83px', '+'],
    '84px': ['83px', '85px', '84px', 84, '-84px', RawMap['83px'][5] | '84px', '+'],
    '85px': ['84px', '86px', '85px', 85, '-85px', RawMap['84px'][5] | '85px', '+'],
    '86px': ['85px', '87px', '86px', 86, '-86px', RawMap['85px'][5] | '86px', '+'],
    '87px': ['86px', '88px', '87px', 87, '-87px', RawMap['86px'][5] | '87px', '+'],
    '88px': ['87px', '89px', '88px', 88, '-88px', RawMap['87px'][5] | '88px', '+'],
    '89px': ['88px', '90px', '89px', 89, '-89px', RawMap['88px'][5] | '89px', '+'],
    '90px': ['89px', '91px', '90px', 90, '-90px', RawMap['89px'][5] | '90px', '+'],
    '91px': ['90px', '92px', '91px', 91, '-91px', RawMap['90px'][5] | '91px', '+'],
    '92px': ['91px', '93px', '92px', 92, '-92px', RawMap['91px'][5] | '92px', '+'],
    '93px': ['92px', '94px', '93px', 93, '-93px', RawMap['92px'][5] | '93px', '+'],
    '94px': ['93px', '95px', '94px', 94, '-94px', RawMap['93px'][5] | '94px', '+'],
    '95px': ['94px', '96px', '95px', 95, '-95px', RawMap['94px'][5] | '95px', '+'],
    '96px': ['95px', '97px', '96px', 96, '-96px', RawMap['95px'][5] | '96px', '+'],
    '97px': ['96px', '98px', '97px', 97, '-97px', RawMap['96px'][5] | '97px', '+'],
    '98px': ['97px', '99px', '98px', 98, '-98px', RawMap['97px'][5] | '98px', '+'],
    '99px': ['98px', '100px', '99px', 99, '-99px', RawMap['98px'][5] | '99px', '+'],
    '100px': ['99px', '__', '100px', 100, '-100px', RawMap['99px'][5] | '100px', '+']
}

/**
 * @hidden
 */
type MapKeys = {
    '-': '-100px' | '-99px' | '-98px' | '-97px' | '-96px' | '-95px' | '-94px' | '-93px' | '-92px' | '-91px' | '-90px' | '-89px' | '-88px' | '-87px' | '-86px' | '-85px' | '-84px' | '-83px' | '-82px' | '-81px' | '-80px' | '-79px' | '-78px' | '-77px' | '-76px' | '-75px' | '-74px' | '-73px' | '-72px' | '-71px' | '-70px' | '-69px' | '-68px' | '-67px' | '-66px' | '-65px' | '-64px' | '-63px' | '-62px' | '-61px' | '-60px' | '-59px' | '-58px' | '-57px' | '-56px' | '-55px' | '-54px' | '-53px' | '-52px' | '-51px' | '-50px' | '-49px' | '-48px' | '-47px' | '-46px' | '-45px' | '-44px' | '-43px' | '-42px' | '-41px' | '-40px' | '-39px' | '-38px' | '-37px' | '-36px' | '-35px' | '-34px' | '-33px' | '-32px' | '-31px' | '-30px' | '-29px' | '-28px' | '-27px' | '-26px' | '-25px' | '-24px' | '-23px' | '-22px' | '-21px' | '-20px' | '-19px' | '-18px' | '-17px' | '-16px' | '-15px' | '-14px' | '-13px' | '-12px' | '-11px' | '-10px' | '-9px' | '-8px' | '-7px' | '-6px' | '-5px' | '-4px' | '-3px' | '-2px' | '-1px'
    '0': '0px'
    '+' : '1px' | '2px' | '3px' | '4px' | '5px' | '6px' | '7px' | '8px' | '9px' | '10px' | '11px' | '12px' | '13px' | '14px' | '15px' | '16px' | '17px' | '18px' | '19px' | '20px' | '21px' | '22px' | '23px' | '24px' | '25px' | '26px' | '27px' | '28px' | '29px' | '30px' | '31px' | '32px' | '33px' | '34px' | '35px' | '36px' | '37px' | '38px' | '39px' | '40px' | '41px' | '42px' | '43px' | '44px' | '45px' | '46px' | '47px' | '48px' | '49px' | '50px' | '51px' | '52px' | '53px' | '54px' | '55px' | '56px' | '57px' | '58px' | '59px' | '60px' | '61px' | '62px' | '63px' | '64px' | '65px' | '66px' | '67px' | '68px' | '69px' | '70px' | '71px' | '72px' | '73px' | '74px' | '75px' | '76px' | '77px' | '78px' | '79px' | '80px' | '81px' | '82px' | '83px' | '84px' | '85px' | '86px' | '87px' | '88px' | '89px' | '90px' | '91px' | '92px' | '93px' | '94px' | '95px' | '96px' | '97px' | '98px' | '99px' | '100px'
}

/**
Describes a map of pixel relationships
*/
export type PixelMap = CreateMap<MapKeys, RawMap>
